/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.gvsig.mini.common;

public interface ILogHandler {
	
	/**
	 * Configure the log. Sets the logging level, the appenders, formatters, etc.
	 */
	public void configureLog();
		
	
	/**
	 * Sets the params to a Logger instance
	 * @param log The logger 
	 */
	public void configureLogger(Object log);	
	
	/**
	 * Logs a message and a exception using a generic logger and a specified level
	 * @param logger The logger instance
	 * @param message The message to log
	 * @param exception The exception to log
	 * @param level The log level
	 */
	public void log(Object logger, String message, Throwable exception, int level);
	
	/**
	 * Returns the absolute path where the log files are going to be stored
	 * @return
	 */
	public String getLogDirectory();
	
	/**
	 * Returns the name of the file where to log
	 * @return
	 */
	public String getLogFileName();
}
