/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Pequea y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.gvsig.mini.common;

/**
 * A Wrapper for Integer Rectangles. Each platform (Android, CLDC, J2SE...) Should implement this interface
 * @author aromeu
 *
 */
public interface IRect {
	
	/**
	 * Sets the values of the Rectangle
	 * @param left
	 * @param top
	 * @param right
	 * @param bottom
	 */
	public void set(int left, int top, int right, int bottom);
	
	/**
	 * Returns true if the properties of the current IRect instance intersects with the values
	 * @param left
	 * @param top
	 * @param right
	 * @param bottom
	 * @return
	 */
	public boolean intersects(int left, int top, int right, int bottom);
	
	/**
	 * Computes the area of the rectangle
	 * @return The area
	 */
	public int getArea();

}
