/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.gvsig.mini.utiles;

import java.util.Collection;
import java.util.Vector;

/**
 * Class to sort a Vector of Strings. The string are in the format: 0|OSM...
 * 1|OSMASDFASD... The sorter takes the number at the beginning and orders the
 * Vector from 0 to N
 * 
 * @author aromeu
 * 
 */
public class LayersSorter extends QuickSorter {

	public LayersSorter() {

	}

	public Collection sort(Collection layers) {
		try {
			Vector l = (Vector) layers;
			final int size = l.size();

			String[] temp = new String[size];

			for (int i = 0; i < size; i++) {
				temp[i] = l.elementAt(i).toString();
			}
			quicksort(temp);

			Vector temp2 = new Vector(size);
			String layerName = null;
			for (int i = 0; i < size; i++) {
				layerName = temp[i];
				try {
					int index = layerName.indexOf("|");
					layerName = layerName.substring(index + 1,
							layerName.length());
					temp2.add(layerName);
				} catch (Exception e) {
					temp2.addElement(temp[i]);
				}

			}
			return temp2;
		} catch (Exception e) {
			return null;
		}
	}

	// is x < y ?
	public boolean less(final Object x, final Object y) {
		try {
			final int index = x.toString().indexOf("|");
			final int index2 = y.toString().indexOf("|");

			if (index == -1 && index2 == -1) {
				return lessAlphabetically(x, y);
			} else if (index == -1)
				return false;
			else if (index2 == -1)
				return false;

			String num = x.toString().substring(0, index);
			String num2 = y.toString().substring(0, index2);

			int position = Integer.valueOf(num).intValue();
			int position2 = Integer.valueOf(num2).intValue();

			return position < position2;

		} catch (Exception e) {
			return false;
		}

	}

	public boolean lessAlphabetically(Object x, Object y) {
		try {
			String[] x1 = x.toString().toLowerCase().split(">");
			String[] y1 = y.toString().toLowerCase().split(">");

			String xx = x1[1] + ">" + x1[0];
			String yy = y1[1] + ">" + y1[0];

			char ix = xx.charAt(0);
			char iy = yy.charAt(0);

			int length = Math.min(xx.length(), yy.length());

			for (int i = 1; i < length; i++) {
				if (ix == iy) {
					ix = xx.charAt(i);
					iy = yy.charAt(i);
				} else {
					return (ix < iy);
				}
			}
			return (ix < iy);
		} catch (Exception ignore) {
			return false;
		}
	}
}
